{                                                                           }
{ PROUTILS - fixdate                                                        }
{ Copyright (c) 1993 - 1994 Frontier Enterprises                            }
{ Written by Justin Kuntz                                                   }
{                                                                           }
{ Release Version 1.0 -- June 2, 1994                                       }

program fixdate;

uses dos, crt, fecommon, sayget4;
var
   offset : byte;
   TempS  : string;

PROCEDURE ParseStr(VAR NewStr : OpenString);
          BEGIN
               Offset := POFSIS(TempS);
               IF Offset > 0 THEN
               BEGIN
                    NewStr := Copy(TempS, 1, Offset-1);
                    TempS  := LTRIM(Copy(TempS, Offset, Length(TempS)));
               END
               ELSE
               BEGIN
                    NewStr := TempS;
                    TempS  := '';
               END;
          END;

FUNCTION WhiteSpaces(s : String) : Word;
         VAR
            Continue : Boolean;
            c, x     : Word;
         BEGIN
              c        := 1;
              x        := 0;
              Continue := True;
              WHILE Continue AND (c < Ord(s[0])) DO
              BEGIN
                   CASE s[c] OF
                        Chr(0)   : {do nothing};
                        Chr(9)   : x := x + 8;
                        Chr(32)  : x := x + 1;
                   ELSE Continue := False;
                   END;
                   Inc(c);
              END;
              WhiteSpaces := x;
         END;

procedure process;
          var
             infile, outfile               : text;
             ReadStr, filename, size, date : string;
          begin
               writeln('Working...');
               assign(infile, paramstr(1));
               reset(infile);
               assign(outfile, paramstr(2));
               rewrite(outfile);
               while not eof(infile) do
               begin
                    readln(infile, ReadStr);
                    TempS := ReadStr;
                    ParseStr(filename);
                    ParseStr(size);
                    ParseStr(date);
                    if WhiteSpaces(ReadStr) < 30 then
                    begin
                         if length(date) = 7 then date := '0' + date;
                         writeln(outfile, filename + ' ' + size + ' ' + date + ' ' + TempS);
                    end
                    else
                    begin
                         writeln(outfile, ReadStr);
                    end;
               end;
               close(infile);
               close(outfile);
          end;

begin
     feinfo;
     writeln;
     if paramcount <> 2 then
     begin
          writeln('Usage: fixdate <input file> <output file>');
     end
     else if not fileexists(paramstr(1)) then
     begin
          writeln('File not found: ' + paramstr(1));
     end
     else if fileexists(paramstr(2)) then
     begin
          writeln('File already exists: ' + paramstr(2));
     end
     else process;
end.